VERSION 5.00
Begin VB.Form frmPetersMap 
   Caption         =   "The Peters Map Construction"
   ClientHeight    =   7635
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   10935
   LinkTopic       =   "Form1"
   ScaleHeight     =   509
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   729
   StartUpPosition =   3  'Windows-Standard
   Begin VB.CommandButton cmdDrawMap 
      Caption         =   "draw map"
      Height          =   375
      Left            =   60
      TabIndex        =   3
      Top             =   60
      Width           =   2295
   End
   Begin VB.CommandButton cmdSavePic 
      Caption         =   "save as ""PetersMap.bmp"""
      Height          =   375
      Left            =   2460
      TabIndex        =   2
      Top             =   60
      Width           =   2295
   End
   Begin VB.CommandButton cmdQuit 
      Caption         =   "quit"
      Height          =   375
      Left            =   4860
      TabIndex        =   1
      Top             =   60
      Width           =   2295
   End
   Begin VB.PictureBox picMap 
      Appearance      =   0  '2D
      AutoRedraw      =   -1  'True
      BackColor       =   &H80000005&
      BorderStyle     =   0  'Kein
      ForeColor       =   &H80000008&
      Height          =   6900
      Left            =   60
      ScaleHeight     =   -462
      ScaleMode       =   0  'Benutzerdefiniert
      ScaleTop        =   231
      ScaleWidth      =   720
      TabIndex        =   0
      Top             =   600
      Width           =   10800
   End
End
Attribute VB_Name = "frmPetersMap"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim iPolyID      As Integer 'number of polygon
Dim cCountryName As String  'name of country
Dim iNum         As Integer 'number of coordinates per polygon
Dim dLat()       As Double  'Latitude (Degrees)
Dim dLng()       As Double  'Longitude (Degrees)

Dim iFileNo      As Integer
Dim i            As Integer 'Counter
Dim d            As Double  'Counter

Private Sub DrawGrid()
   picMap.Line (picMap.ScaleLeft, picMap.ScaleTop)-(picMap.ScaleWidth - 1, picMap.ScaleTop * -1 + 1), RGB(150, 150, 150), B
   For d = -168.6 To 168.6 Step 36
      picMap.Line (Lng2PetersX(CDbl(d)), picMap.ScaleTop)-(Lng2PetersX(CDbl(d)), picMap.ScaleHeight), RGB(150, 150, 150)
   Next
   For i = -90 To 90 Step 18
      picMap.Line (0, Lat2PetersY(CDbl(i)))-(picMap.ScaleWidth, Lat2PetersY(CDbl(i))), RGB(150, 150, 150)
   Next
End Sub

Private Sub cmdDrawMap_Click()
   Dim sFileName As String
   sFileName = App.Path + "\World.txt"
   iFileNo = FreeFile(0) 'determine next free file number
   Open sFileName For Input As #iFileNo
   iNum = 0
   Do While Not EOF(iFileNo)
      Input #iFileNo, iPolyID
      Input #iFileNo, cCountryName
      Input #iFileNo, iNum
      
      ReDim dLat(iNum)
      ReDim dLng(iNum)
      For i = 1 To iNum
         Input #iFileNo, dLat(i), dLng(i)
         If i >= 2 Then
            picMap.Line (Lng2PetersX(CDbl(dLng(i - 1))), Lat2PetersY(CDbl(dLat(i - 1))))-(Lng2PetersX(CDbl(dLng(i))), Lat2PetersY(CDbl(dLat(i)))), RGB(0, 0, 0)
         End If
      Next
      picMap.Refresh
   Loop
   Close #iFileNo
   Call DrawGrid
End Sub

Private Sub cmdQuit_Click()
   End
End Sub

Private Sub cmdSavePic_Click()
   Dim sFileName As String
   sFileName = App.Path + "\PetersMap.bmp"
   SavePicture picMap.Image, sFileName
End Sub

Private Sub Form_Load()
   Dim Zone0      As Double  'area of ellipsoidzone between equator and phi = 1N
   Dim ZoneMax    As Double  'area of ellipsoidzone between equator and phi = 90N (northpole)
   Dim Segment0   As Double  'area of zonesegment (Zone0 / 180)
   Dim SegmentMax As Double  'area of zonesegment (ZoneMax / 180)
   Dim Baseline   As Double  'length of baseline

   'Friedrich Wilhelm Bessel 1841
   d_a = 6377.397155
   d_b = 6356.07896325
   d_f = 3.3427731144651E-03
   d_e = Sqr(1 - (1 - d_f) ^ 2)
   
   MapWidth = 720
   Zone0 = PetersF(d_b, d_e, Phi2Psi(1, d_e))
   Segment0 = Zone0 / 180
   Baseline = Sqr(Segment0)
   MapFactor = (MapWidth / 180) / Baseline
   ZoneMax = PetersF(d_b, d_e, Phi2Psi(90, d_e))
   SegmentMax = ZoneMax / 180
   MapHeight = (SegmentMax / Baseline * MapFactor) * 2
   picMap.Width = MapWidth
   picMap.Height = MapHeight
   picMap.ScaleMode = 0
   picMap.ScaleLeft = 0
   picMap.ScaleWidth = MapWidth
   picMap.ScaleTop = MapHeight / 2
   picMap.ScaleHeight = MapHeight * -1
End Sub

